
import java.io.*;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class HelpWin extends JFrame 
{
	public static int INSTRUMENTSHELP = 1, SYMBOLSHELP= 2, ABOUT=3; 
	private String filename="";
	
	

	public HelpWin(int type) {
		
		if(type == INSTRUMENTSHELP){
		        setTitle("MIDI Instrument Numbers");		        				     
			filename = "hlp/Instruments.hlp";
		} 
		else if (type == SYMBOLSHELP){
			setTitle("Symbols");
			filename = "hlp/Symbols.hlp";
		}
		
	}
	private void init() {
	        String text="";
	        InputStreamReader in;
	        InputStream is;
	        FileInputStream fis;
	        
                is=getClass().getResourceAsStream(filename);
                if(is==null){
                   try{    
                       is=new FileInputStream(filename);
                   }
                   catch(FileNotFoundException fnfe){
                   	System.err.println("ooops");
                   	text=filename +" not found";
                   }
                }
		
		if(is!=null){		
        		in=new InputStreamReader(is);
        		
        		
        	        StringBuffer textbuf=new StringBuffer(text);
        
        	        int inchar=0;
        	        while(inchar>=0){
        	                try{
        	        		inchar=in.read();
        	        		
        	        		if(inchar>0){
        	        			textbuf.append((char)inchar);
        	        		}
        	        	}catch(IOException e){}
        	        }
        	        try{
        	        
        	        	in.close();
        	        }catch(Exception e){}
        	        text=textbuf.toString();
        	        
	        }
		JTextArea helpTextArea = new JTextArea(text,20, 60);
		helpTextArea.setLineWrap(false);
		helpTextArea.setEditable(false);
		helpTextArea.setCaretPosition(0);/***/
		// want a font that has same screen width for each character
		helpTextArea.setFont(new Font("monospaced", Font.PLAIN, 12));

	        JScrollPane helpScrollPane=new JScrollPane(helpTextArea);
		getContentPane().add(helpScrollPane);
		
	}
	
	void showHelp(){
		init();
		pack();
                show();                
	}


}