


class LTools{

	static TYParse expressionParser=new TYParse();
	
	// Get numerical expressions starting at 'position' in 'Str'
	// and store them in StrBuf. They can then be passed to 
	// expressionParser to evaluate them.
	static int getNumericChars(String Str, int position, StringBuffer StrBuf){
                // starting at 'position' in str, see if there is a number
                // or numerical expression there.
                // Store the characters making up the number
                // in StrBuf. Return the first position where no more of the
                // number was found. If no number is found, return
                // the starting position. ( ()'s count as part of the number)
                int i=position;                

                boolean inparen=false;
                int L=Str.length();
                char c=Str.charAt(i); 
                int level=0;         
                StrBuf.setLength(0);
                
                if(c=='('){ 
                     StrBuf.append(c);
                     level++;
                     i++;
                     if(i<L)
                        c=Str.charAt(i);
                     while(i<L && level>0){
                         if(c=='(') level++;
                         if(c==')') level--;
                         StrBuf.append(c);    
                         i++;
                         if(i<L)
                           c=Str.charAt(i);
                     }
                     
                }
                else{ // just store numerical characters in StrBuf
                        while( i<L && (c>='0'&&c<='9')||c=='.'){
                                     		     	
                             StrBuf.append(c);    
                             
                             i++;   // go to the next index
                             if(i<L)
                               c=Str.charAt(i); // get the next character
                             
                        }
                }
                if(level>0){// an error in the string
                }
      		               
      		return i;
      }
      
      static String formatLineIn(String str){
		//remove *all* spaces and truncate at '#'
		int L=str.length();
		StringBuffer sb=new StringBuffer("");
		for (int i=0;i<L;i++){
		    char c=str.charAt(i);
		    if(c=='#'){
		    	break;
		    }
		    if(!Character.isWhitespace(c))
		       sb.append(c);
		
		}
		return sb.toString();
      }
      
      static String cleanUp(String l) {
                // like formatLineIn, but the only spaces it removes
                // are leading and trailing.
                char commentChar='#';
        	StringBuffer line;
    		// remove leading and trailing spaces
    		line = new StringBuffer(l.trim());
    		// remove comment string
    		StringBuffer temp = new StringBuffer();
    		for (int i = 0; i < line.length(); i ++) {
      			if (line.charAt(i) == commentChar) {
				break;
      			} 
      			else {
				temp.append(line.charAt(i));
      			}
    		}
    		line = temp;
    		return (line.toString()).trim();
      }   
      
      static String removeNumericalContext(String str){
                StringBuffer Buf=new StringBuffer(str);
                
                // remove numerical factors from the given string 'str'
                // remove numbers in parentheses (can include '+' or '-')
                int j=0;// index into Buf
                                                
                while (j<Buf.length()){
                           char charat=Buf.charAt(j);
                           int level=0;
                           if(charat=='('){
                           // everything in between matching '(' and ')'
                           // should be removed. Rather than do this recursively,
                           // we will just delete characters until we reach
                           // the matching ')'
                
                               level++; // keep track of how deeply into nested
                                        // '('s we are
                               Buf.deleteCharAt(j);
                               if(j<Buf.length())
                               charat=Buf.charAt(j);
                               while( (level>0) && j<Buf.length()){
                               // keep deleting until 'level==0'
                                    if(charat==')'){
                                       level--;
                                       
                                    }
                                    if(charat=='('){
                                       level++;                                       
                                    }
                                    Buf.deleteCharAt(j);
                                    if(j<Buf.length())
                                       charat=Buf.charAt(j);
                                    
                               }
                              
                           }
                           
                           else j++;
                           
                           
                }
                // Since numbers not in parentheses are also allowed,
                // remove all other numbers (they can't include '+' or '-')
                j=0;
                while (j<Buf.length()){
                           char charat=Buf.charAt(j);
                           while(j<Buf.length()&& ((charat>'0'&&charat<'9')||charat=='.')){
                                    Buf.deleteCharAt(j);
                                    if(j<Buf.length())
                                       charat=Buf.charAt(j);
                           }
                           j++;                                                      
                }  
                return(Buf.toString());
        }
        static String removeSpaces(String inStr){
		StringBuffer strBuf=new StringBuffer("");
		int L=inStr.length();
		int i=0;
		while(i<L){
		    char c=inStr.charAt(i);
		    //if(!Character.isWhitespace(c) ||(c!='\n'||c!='\r')){
		    if(!Character.isWhitespace(c) ){    
		        
		    	strBuf.append(c);
		    }
		    i++;
		}
		return strBuf.toString();
		      
        }
        static double deg2Rad(double deg){
         	return deg*Math.PI/180.0;
        }	

}