import java.util.*;


class Scale{
       private int[] steps;
       private int numsteps=0;
       private int basenote=0;
       
       private int per=12;
       
       private String name;
       
       static Hashtable scales=new Hashtable();        
       static Scale Major=new Scale(new int[]{0,2,4,5,7,9,11},"Major"),
        	    Twelvetone=new Scale (new int[]{0,1,2,3,4,5,6,7,8,9,10,11},"Twelvetone"),
        	    Penta0=new Scale(new int[]{0,3,5,7,10},"Penta0"),
       		    Penta1=new Scale(new int[]{0,4,7,9,10},"Penta1"),
       		    Penta2=new Scale(new int[]{0,2,4,7,9 },"Penta2"),
       		    minor=new Scale(new int[]{0,2,3,5,7,8,11},"Minor"),
       		    blue1=new Scale(new int[]{0,2,3,4,7,8,9,10},"Blue1"),
       		    whole=new Scale(new int[]{0,2,4,6,8,10},"Whole"),
                    diminished=new Scale(new int[]{0,1,3,4,6,7,9,10},"Diminished"),
                    hijaz=new Scale(new int[]{0 ,1 ,4 ,5 ,7 ,8 ,10},"Hijaz");
        
       public Scale(){
           
       } 
       public Scale(int[] s){
           steps=s;
           numsteps=steps.length;
           if(numsteps>0){
           	int octs=s[numsteps-1]/12 +1;
           	per=12*octs;
           }
       }
       public Scale(int[] s,String nm){
           this(s);
           name=nm;
           scales.put(name,this);
       }
       static Scale toScale(String str){
           Scale newscale=null;
           int nums=0;
           StringBuffer strbuf=new StringBuffer(str);
           StringTokenizer st = new StringTokenizer(str," ,-");
           nums=st.countTokens();
           int[] newsteps=new int[nums];
           int i=0;
           while (st.hasMoreTokens()) {
              
              try{
                 int n= Integer.valueOf(st.nextToken()).intValue();
                 newsteps[i]=n;  
              
                 i++;
              }catch(Exception e){
                   if (i>0)
                      System.err.println("bad scale");
                   return null;
              }
              
           }
           
           newscale=new Scale(newsteps,str);
           
           return newscale;
       } 
       public String getName(){
       		return name;
       }
       int slideto(int p,int mode){

       		/*returns first scale note higher or equal to given pitch*/
                // start counting up the scale from step # 'mode'.
        	int i=0,oct,origdeg;
                int m=mode%numsteps;
                
        	int cnt=0;	
		int p1=p;
        	while (p1<0){
              		cnt++;
              		p1+=per;
        	}
        	oct     = p1/per;
        	origdeg = p1%per;
        	
        	boolean overoct=false;
        	int stepi=steps[i];

		while(stepi<origdeg){ 
                     i++;
                     
                     if(i==numsteps){ 
                       i=0;
                       overoct=true;
                       oct++;
                     }
                     stepi=steps[i];
                     if(overoct) stepi+=per;
                }
                
                i=(i+mode)%numsteps;
                
		return(basenote+(steps[i]+(oct-cnt)*per)&0x7f);
       }
}